﻿Group=Default Group
ModulesStructureVersion=1
Type=Class
Version=1.00
@EndOfDesignText@

'Class module

Sub Class_Globals
	Private DataFileName As String
	Private DataPathName As String
	

End Sub

'Initializes the object. You can add parameters to this method if needed.
Public Sub Initialize
	DataFileName = "Data_Temporary_File.map"
	
	#if B4J
		DataPathName = File.DirApp  'Can used only Windows(MacOS and others can't used)
	#else If B4A	
	    DataPathName = File.DirInternal' Can used only Android
	#else 'B4i
		DataPathName = File.DirTmp  'Can used only iOS
	#End If
'	xui.SetDataFolder("TmpFolder")
'	'Instead of File.DirInternal because File.DirInternal only in B4A
'	DataPathName = xui.DefaultFolder  
End Sub

#Region ----------------------------------------- String Functions
'Returns a string of spaces. The number returned Is set by HowMany.
'<code>
'AddSpaces(5) 'Result: "     "
'</code>
public Sub AddSpaces (HowMany As Int) As String
	Private sb As StringBuilder
	sb.Initialize
	For i=0 To HowMany -1
		sb.Append( " ")
	Next
	Return sb.ToString
	
End Sub

'Returns the position of the SearchFor within YourString.
'<code>
'At("1234567890", "2")  'Result: 1
'</code>
public Sub At (YourString As String, SearchFor As String) As Int
	Return YourString.IndexOf( SearchFor)
End Sub
	
'Converts an encrypted string (XOR) of text To readable format, no key Is needed.
'<code>
'Decrypt( "eb82efcf85ea8fafed9ff087e9")  'Result: "Jim Joe Brown"
'</code>
public Sub Decrypt( YourText As String) As String
	Dim z As String
	Dim oldZahl As Long
	Dim cptZahl As Int = 161
	Dim orgZahl As Long
	Dim subStr As String

	For i = 0 To YourText.Length -1
		oldZahl = cptZahl
		'Entschlüsseln
		If i > (YourText.Length-1) / 2 Then Exit
		subStr = YourText.SubString2( i*2, i*2+2)
		Try
			cptZahl = Bit.ParseInt( subStr, 16)
			orgZahl = Bit.Xor( cptZahl, oldZahl)
		Catch
			orgZahl = 0
		End Try
		z = z & Chr( orgZahl)
	Next
	Return z
End Sub

'Test To see If the string Is empty And returns True If it Is, otherwise returns False.
'<code>
'</code>
public Sub Empty (StringText As String) As Boolean
	Return IsEmpty( StringText)
End Sub

'Converts a string of text To simple encryption (xor), no Key Is needed.
'<code>
'Encrypt("Jim Joe Brown")  'Result: "eb82efcf85ea8fafed9ff087e9"
'</code>
public Sub Encrypt( YourText As String) As String
	Dim z As String
	Dim oldZahl As Long
	Dim cptZahl As Int = 161
	Dim orgZahl As Long
	Dim cptString As String

	For i = 0 To YourText.Length -1
		oldZahl = cptZahl
		'Verschlüsseln
		orgZahl = Asc( YourText.CharAt( i))
		cptZahl = Bit.Xor( orgZahl, oldZahl)
		cptString = Bit.ToHexString( cptZahl)
		If cptString.Length < 2 Then cptString = "0" & cptString
		z = z & cptString
	Next
	Return z
End Sub

'Returns True If the filename passed does exist, otherwise returns False.
'Be sure To include the path like:
'<code>
'If FileExist("/mnt/sdcard/mydata.dat") Then Msgbox("Yes", "The Answer")
'</code>
public Sub FileExist (PathAndFileName As String) As Boolean
	Return File.Exists( "", PathAndFileName)
End Sub

'Returns the position of the SearchFor within YourString.
'<code>
'InString( "1234567890", "2")  'Result: 1
'</code>
public Sub InString (YourString As String, SearchFor As String) As Int
	Return YourString.IndexOf( SearchFor)
End Sub

'Test To see If the string Is empty And returns True If it Is, otherwise returns False.
public Sub IsEmpty (StringText As String) As Boolean
	'https://www.b4x.com/android/forum/threads/isemptystring-function.72647/
	Dim bEmpty As Boolean

	bEmpty = (StringText = Null)      ' Because pure Null
 
	If Not( bEmpty ) Then
		bEmpty = (StringText.CompareTo( Null) = 0)   ' Because origin is field of table bbdd
       
		If Not( bEmpty ) Then
			bEmpty = (StringText.Trim.Length < 1)
		End If
	End If

	Return bEmpty
End Sub

'Returns the Left portion of a string with the number of characters passed
'in Length.
'<code>
'Left( "0123456789", 2)  'Result: "01"
'</code>
public Sub Left (StringText As String, Length As Long) As String
	Private sb As StringBuilder
	sb.Initialize
	Return sb.Append( StringText).Remove( Length, StringText.Length).ToString
End Sub

'Returns the length of the string.
'<code>
'Len( "0123456789")'Return: 10
'</code>
public Sub Len (StringText As String) As Long
	Return StringText.Length
End Sub

'Converts a List object To a String.
public Sub ListToString (YourList As List, Sorted As Boolean, Ascending As Boolean) As String
	Private sb As StringBuilder
	sb.Initialize
	If Sorted Then YourList.Sort( Ascending)
	For Each Item As String In YourList
		sb.Append( Item).Append( " ")
	Next
	If sb.Length > 0 Then sb.Remove( sb.Length -1, sb.Length)
	Return sb.ToString
End Sub

'Converts a List object To a String Array.
public Sub ListToStringArray (YourList As List, Sorted As Boolean, Ascending As Boolean) As String()
	If Sorted Then YourList.Sort( Ascending)
	Dim Ret( YourList.Size) As String
	For i=0 To YourList.Size -1
		Ret( i) = YourList.Get( i)
	Next
	Return Ret
End Sub

'Returns the string converted To Lowercase characters.
'<code>
'Lower( "Jim Joe Brown")  'Result: "jim joe brown"
'</code>
public Sub Lower (StringText As String) As String
	Return StringText.ToLowerCase
End Sub

'Returns a new string with the leading spaces removed.
'<code>
'LTrim( "  Jim Joe Brown  ")  'Return: "Jim Joe Brown  "
'</code>
public Sub Ltrim (StringText As String) As String
	Do While StringText.StartsWith( " ")
		StringText = StringText.SubString( 1)
	Loop
	Return StringText
End Sub

'Returns the a new String For how ever many characters passed in Length from
'a starting position passed in Start.
'Example:
'<code>
'Mid( "This is a long line of text", 10, 4)  'Result: "long"
'</code>
public Sub Mid (StringText As String, Start As Int, Length As Int) As String
'	Private sb As StringBuilder
'	sb.Initialize
'	If Length > StringText.Length Then Length = StringText.Length
'	sb.Append( StringText).Remove( Start + Length, StringText.Length).Remove( 0, Start)
'	Return sb.ToString
	
	'Classic
	Return StringText.SubString2( Start, Start + Length)
End Sub

'Used To extract text from a string between To other blocks of text.
'<code>
'MidExtract("Dr. Jim Joe Brown", "Jim", "Brown") 'Result: (ArrayList) [ Joe ]
'MidExtract("Dr. Jim [Joe] Brown", "[", "]") 'Result: (ArrayList) [ Joe ]
'MidExtract("this is a [sample] string* with [some] special words. [another one]", "[", "]") 'Result: (ArrayList) [sample, some, another one]
'</code>
public Sub MidExtract (StringText As String, Start As String, EndAt As String) As List
	Private li As List
	li.Initialize
	
	Private Matcher1 As Matcher
'	\[([^]]+)\]
	'Escape Special Chars
	Start = Start.Replace( "[", "\[").Replace( "]", "\]").Replace( "*", "\*").Replace( "?", "\?")
	EndAt = EndAt.Replace( "[", "\[").Replace( "]", "\]").Replace( "*", "\*").Replace( "?", "\?")
	Private pattern As String = Start & "([^]]+)" & EndAt
	Matcher1 = Regex.Matcher( pattern, StringText)
	Do While Matcher1.Find
		li.Add( Matcher1.Group(1))
	Loop
	Return li
End Sub

'Works like the Mid$ function in Visual Basic.
public Sub MidS (StringText As String, StartAt As Int) As String
	Return StringText.SubString(StartAt)
End Sub

'Used To pad a string with a selected character. If Post = True the padding will follow
'any text in the string, If Post = False, the padding will be before the text. Length Is
'the total length For the padded string. PadWith Is the selected character To use For the
'padding.
'<code>
'Pad("Jimmy Joe", "+", 20, True)  'Result: "Jimmy Joe+++++++++++"
'</code>
public Sub Pad (Text As String, PadWith As String, Length As Int, Post As Boolean) As String
	'Classic
	Private Str As String = ""
	Private FillStr As String
	If PadWith= "" Then PadWith = "*"
	For i=0 To Length - Text.Length
		FillStr = FillStr & PadWith.CharAt(0)
	Next
	If Post Then
		Str = Text & FillStr
	Else
		Str = FillStr & Text
	End If
	Return Str
End Sub

'Returns the string in proper format.
'Example:
'<code>
'Proper( "jim joe brown")  'Result: "Jim Joe Brown"
'</code>
'This function will Return: "Jim Joe Brown"
public Sub Proper (StringText As String) As String
	Dim sb As StringBuilder
	
	sb.Initialize
	sb.Append( StringText)
	Dim m As Matcher = Regex.Matcher("\b\w", StringText)
	Do While m.Find
		sb.Remove( m.GetStart(0), m.GetEnd(0)).Insert( m.GetStart(0), m.Match.ToUpperCase)
	Loop
	Return sb.ToString
End Sub

'Repeats any character passed, a selected number of Times.
'<code>
'Replicate( "+", 5)  'Result: "+++++"
'</code>
public Sub Replicate (mChar As String, Times As Int) As String
	Private sb As StringBuilder
	sb.Initialize
	For i=0 To Times -1
		sb.Append( mChar)
	Next
	Return sb.ToString
End Sub

'Returns the Right portion of a string with the number of characters passed
'in Length.
'<code>
'Right( "0123456789", 2)  'Result: "89"
'</code>
public Sub Right (StringText As String, Length As Long) As String
	Private sb As StringBuilder
	sb.Initialize
	Return sb.Append( StringText).Remove(0, StringText.Length - Length).ToString
End Sub

'Returns a string of ramdom characters (a-z) with a length specified by StringLength. CharacterType tells
'the function what Type of characters To Return.
'CharacterType = 0 For Upper And Lower Case
'CharacterType = 1 For Upper Case only
'CharacterType = 2 For Lower Case only
'<code>
'RndChrGen(  10, 0) 'Result: "uBcgOIEyuM"
'</code>
public Sub RndChrGen (StringLength As Int, CharacterType As Int) As String
	Dim Pool As String = "abcdefghijklmnopqrstuvwxyz"
	Select CharacterType
		Case 0
			Pool = Pool.ToLowerCase & Pool.ToUpperCase
		Case 1
			Pool = Pool.ToUpperCase
		Case 2
			Pool = Pool.ToLowerCase
		Case Else
			Pool = Pool.ToLowerCase	& Pool.ToUpperCase
	End Select
	
	Dim sb As StringBuilder
	sb.Initialize
	For i=0 To StringLength -1
		Dim p As Int = Rnd( 0, Pool.Length)
		sb.Append( Pool.SubString2( p, p+1))
	Next
	Return sb.ToString
End Sub

'Returns a new string with the trailing spaces removed.
'<code>
'RTrim( "  Jim Joe Brown  ")  'Result: "  Jim Joe Brown"
'</code>
public Sub Rtrim (StringText As String) As String
	Do While StringText.EndsWith( " ")
		StringText = StringText.SubString2( 0, StringText.Length -1)
	Loop
	Return StringText
End Sub

'Returns a LIST of items from the string split At the Delimiter.
'<code>

'Split("This is a test string.", " ")  'Result: (ArrayList) [This, is, a, test, string.]
'</code>
public Sub Split (CurrentString As String, Split_At_Delimiter As String) As List
	Private li As List
	
	li.Initialize
	li = Regex.Split( Split_At_Delimiter, CurrentString)
	Return li
End Sub

public Sub Split2 (CurrentString As String, Split_At_Delimiter As String) As String()
	Dim mystr() As String = Regex.Split( Split_At_Delimiter, CurrentString)
		Return mystr
End Sub

'Returns just the one element selected with GetElement from the string.
'<code>
'SplitGetWord("This is a test string.", " ", 3)  'Result: "test"
'</code>
public Sub SplitGetWord (CurrentString As String, Split_At_Delimiter As String, GetElement As Int) As String
    
	Return Regex.Split( Split_At_Delimiter, CurrentString)( GetElement)
End Sub

'Used To sort a String Array. Sort will be in Ascending order If Ascending = True.
'<code>
'StrArraySort( Array As String( "a", "c", "b"), True)  'Result: StringArray( a, b, c)
'</code>
public Sub StrArraySort (StringArray() As String, Ascending As Boolean) As String()
	Private li As List
	li.Initialize2( StringArray)
	'li.AddAll( StringArray)
	li.Sort( Ascending)
	Dim Ret( li.Size) As String
	For i=0 To li.Size -1
		Ret( i) = li.Get( i)
	Next
	Return Ret
End Sub

'Converts a String Array To a List object.
'<code>
'StringArrayToList( Array As String( "a", "c", "b"), True, True)  'Result: (ArrayList) [a, b, c]
'</code>
public Sub StringArrayToList (StringArray() As String, Sorted As Boolean, Ascending As Boolean) As List
	Private li As List
	li.Initialize2( StringArray)
	If Sorted Then li.Sort( Ascending)
	Return li
End Sub

'Convert a String To a List object. This will split the string between words.
'<code>
'StringToList( "Jim Joe Brown", True, True)  'Return: (ArrayList) [Brown, Jim, Joe]
'</code>
public Sub StringToList (StringText As String, Sorted As Boolean, Ascending As Boolean) As List
	Private li As List
	
	li.Initialize
	li = Regex.Split( " ", StringText)
	If Sorted Then li.Sort( Ascending)
	Return li
End Sub

'Used To replace text in a string with new text.
'<code>
'Stuff("I will tell you that joe is a good friend!", "Joe Brown", "joe")
''Return: "I will tell you that Joe Brown is a good friend!"
'</code>
public Sub Stuff (CurrentText As String, InsertInString As String, RemoveFromString As String) As String
	Return CurrentText.Replace( RemoveFromString, InsertInString)
End Sub

'Returns a new string with leading And trailing spaces removed.
'<code>
'Trim( "  Jim Joe Brown  ")  'Result: "Jim Joe Brown"
'</code>
public Sub Trim (StringText As String) As String
	Return StringText.Trim
End Sub

'Returns the string converted To Uppercase characters.
'<code>
'Upper( "Jim Joe Brown")  'Result: "JIM JOE BROWN"
'</code>
public Sub Upper (StringText As String) As String
	Return StringText.ToUpperCase
End Sub

'Returns the numerical value of a string. If the string contains no value it returns 0.
'<code>
'Val( "12345")  'Result: 123456
'</code>
public Sub Val (StringText As String) As Double
	If IsNumber( StringText) Then
		Return StringText
	Else
		Return 0
	End If
End Sub

'--- joins a list together as a string
'--- if you do not want a join char then pass in ""
Public Sub Join(lst As List, joinChar As Object) As String
 
    Dim retStr As StringBuilder
    retStr.Initialize
 
    For Each str In lst
        retStr.Append(str).Append(joinChar) 
    Next
 
    Return retStr.ToString
 
End Sub

'--- joins a array together as a string
'--- if you do not want a join char then pass in ""
Public Sub Join2(arr() As String, joinChar As Object) As String
 
    Dim retStr As StringBuilder
    retStr.Initialize
 
    For Each str In arr
        retStr.Append(str).Append(joinChar) 
    Next
 
    Return retStr.ToString
 
End Sub

'--- joins a list together as a string
'--- if you do not want a separator/join char then pass in ""
Public Sub Join3(Lst As List, Separator As Object) As String
 
    If Lst.Size = 0 Then    'pessimists of the world, unite!
        Return ""
    End If

    Dim Joined As StringBuilder
    Joined.Initialize
 
    Joined.Append(Lst.Get(0))
    For I = 1 To Lst.Size - 1     'skips first item since already done
        Joined.Append(Separator).Append(Lst.Get(I))
    Next 

    Return Joined.ToString
 
End Sub

'This Is a single line If conditional test. If Value1 Is True, Value2 Is returned, otherwise
'Value3 will be returned. Works with strings And booleans.
'<code>
'Msgbox(IfSelect("Bob"="Jim", "They are the same", "They are not the same"), "The Answer")
''or
'MyBoolean = IfSelect(FirstTime = True, StartMyService = True, StartMyService = False)
'</code>
public Sub IfSelect (Value1 As String, Value2 As String, Value3 As String) As String
	If Value1 Then
		Return Value2
	Else
		Return Value3
	End If
End Sub
#End Region ------------------------------------- String functions

#Region ----------------------------------------- Data functions
'This will erase all data saved with the SaveData function stored in the
'temporary vault.
public Sub EraseData
	If File.Exists( DataPathName, DataFileName)Then
		File.Delete( DataPathName, DataFileName)
	End If
End Sub

'Gets data from the temporary vault.
'<code>
'EditText1.Text = SF.GetData("EnteredName")
'</code>
'The Key Is Case sensitive.
public Sub GetData (Key As Object) As Object
	Private ma As Map
	ma.Initialize
	If File.Exists( DataPathName, DataFileName) Then
		ma = File.ReadMap( DataPathName, DataFileName)
	End If
	Return ma.Get( Key)
End Sub

'Save data passed in a temporary File.
'<code>
'SaveData("ScreenTitle", MyVar)
''or
'SaveData("EnteredName", EditText1.Text)
'</code>
public Sub SaveData (Key As Object, Data As Object)
	If DataFileName = "" Then DataFileName = "Data_Temporary_File.map"
	Private ma As Map
	ma.Initialize
	If File.Exists( DataPathName, DataFileName) Then
		ma = File.ReadMap( DataPathName, DataFileName)
	End If
	ma.Put( Key, Data)
	File.WriteMap( DataPathName, DataFileName, ma)
End Sub
#End Region ------------------------------------- Data functions
'
#Region ----------------------------------------- B4A functions

#If B4A

'Returns information about the devices screen. You can pass these parameters:
'Pass "W" For Width
'Pass "H" For Height
'Pass "S" For Scale
'Pass "D" For DPI
'<code>
'ScrInfo("W")
'</code>
public Sub ScrInfo ( p As String) As String
	Select p.ToUpperCase
		Case "W"
			Return 100%x
		Case "H"
			Return 100%y
		Case "S"
			Return Density
		Case "D"
			Return Density *160
		Case Else
			Private dlv As String = GetDeviceLayoutValues.toString
			Return dlv
	End Select
End Sub

'Returns external/physical SD Card directory. This function may Not Return the correct store
'on an Android OS above 4.1. This Is due To changes made To the OS system in the newer versions.
'Returns "", If the store can Not be read.
'Returns external/physical SD Card directory
Public Sub getSDCardPath() As String
	Private CardPaths As List
	CardPaths.Initialize
	For Each item As String In SDCards
		If item.EndsWith( "emulated") Then
			Continue
		Else
			Exit
		End If
	Next
	Return item
End Sub

public Sub SDCards As List
	' mrred128: https://www.b4x.com/android/forum/threads/getting-the-mount-points-nailed.44289/#post-269713
	Private Result As List
	Result.Initialize
	Private tr As TextReader
	If File.Exists( "/proc","mounts") Then
		tr.Initialize(File.OpenInput("/proc","mounts"))
		Private line As String
		
		Do While True
			line = tr.ReadLine
			If line = Null Then Exit
			' cols: dev mount type options ......
			Private Col() As String = Regex.Split(" ",line)
			' things to ignore
			' put your false positive mount points here
			If Col(1).StartsWith("/dev") Then Continue
			If Col(1).StartsWith("/proc") Then Continue
			If Col(1).StartsWith("/sys") Then Continue
			If Col(1).StartsWith("/system") Then Continue
			If Col(1).StartsWith("/firmware") Then Continue
			If Col(1).StartsWith("/data") Then Continue
			If Col(1).StartsWith("/mnt") Then Continue
'			If Col(1).StartsWith("/mnt/shell") Then Continue
'			If Col(1).StartsWith("/mnt/runtime") Then Continue
			' vfat is what we are interested in, but my nexus 5 also uses fuse
			If Col(2) = "vfat" Or Col(2) = "fuse" Then
				Private s As String = Col(1)
				Result.Add(s)
			End If
		Loop
		tr.Close
	End If
	Return Result
End Sub

''Same As MsgBox but only needs one parameter.
'Sub MB (Message As String)
'	Msgbox( Message, "")
'End Sub
#End If

#End Region ------------------------------------- B4A functions

#Region ----------------------------------------- Date functions
'Returns the number of the current week, 1-52 from the date passed To MyDate.
'<code>
'CurrentWeek( "01/31/2019")  'Return: 5
'</code>
public Sub CurrentWeek (MyDate As String) As Int
	Return DateTime.GetDayOfWeek(DateTime.dateparse(MyDate))
End Sub

'Returns the day of the month like 1-31, from the date passed To MyDate.
'<code>
'DayOfMonth( "01/31/2019")  'Return: 31
'</code>
public Sub DayOfMonth (MyDate As String) As Int
	Return DateTime.GetDayOfMonth( DateTime.DateParse( MyDate))
End Sub

'Returns the number of the current month 1-12 As Int Type, from the date passed To MyDate.
'<code>
'Month( "01/31/2019")  'Result: 1
'</code>
public Sub Month (MyDate As String) As Int
	Return DateTime.GetMonth(DateTime.DateParse( MyDate))
End Sub

'Returns the Name the current month As a String like January, etc., from the date passed To MyDate.
'<code>
'MonthName( "01/31/2019")  'Result: "January"
'</code>
public Sub MonthName (MyDate As String) As String
	Return DateUtils.GetMonthName(DateTime.DateParse(MyDate))
End Sub

'Returns a new date adding Or subtracting HowManyDays. HowManyDays can be positive Or
'negative numbers.
'<code>
'NewDate( "01/31/2019", 2)  'Result: "02/02/2019"
'</code>
public Sub NewDate (DatePassed As String, HowManyDays As Int) As String
	Private Ticks As Long = DateTime.DateParse( DatePassed)
	Ticks = Ticks + (HowManyDays * DateTime.TicksPerDay)
	Return DateTime.Date( Ticks)
End Sub

'Returns the numbers of days passed between the two dates passed.
'<code>
'NumOfDaysBetween( "01/31/2019", "03/31/2019")  'Result: 59
'</code>
public Sub NumOfDaysBetween (CurrentDate As String, OtherDate As String) As Int
	Private Ticks1 As Long = DateTime.DateParse( CurrentDate)
	Private Ticks2 As Long = DateTime.DateParse( OtherDate)
	Private Days As Long = Floor( (Ticks1 - Ticks2) / DateTime.TicksPerDay)
	Return Abs( Days)
End Sub

'Returns True If the Date1 And the Date2 are within x Days(DateRange) of each other.
'Pass the dates As Strings.
'<code>
'SearchDate( "01/31/2019", "03/31/2019", 60)  'Result: True
'</code>
public Sub SearchDate (Date1 As String, Date2 As String, DateRange As Int) As Boolean
	Private Ticks1 As Long = DateTime.DateParse( Date1)
	Private Ticks2 As Long = DateTime.DateParse( Date2)
	Private Days As Long = Floor( (Ticks1 - Ticks2) / DateTime.TicksPerDay)
	Return Abs( Days) <= Abs( DateRange)
End Sub

'Returns the devices date.
'<code>
'Today  'Result: "01/31/2019"
'</code>
public Sub Today () As String
	Return DateTime.Date( DateTime.Now)
End Sub

'Returns True If the date passed Is a Valid date.
'<code>
'ValidDate( "01/31/2019")  'Result: True
'</code>
public Sub ValidDate (ChkDate As String) As Boolean
	Try
		DateTime.DateParse( ChkDate)
		Return True
	Catch
		Return False
	End Try
End Sub

'Returns the number of the day of the week 1-7 As a String, from the date passed To MyDate.
'<code>
'WeekDay( "01/31/2019")  'Result: 5
'</code>
public Sub WeekDay (MyDate As String) As String
	Return DateTime.GetDayOfWeek( DateTime.DateParse(MyDate))
End Sub

'Returns the name of the day of the week like Sunday, Monday, etc., from the date passed To MyDate.
'<code>
'WeekName( "01/31/2019")  'Result: "Thursday"
'</code>
public Sub WeekName (MyDate As String) As String
	Private Ticks As Long = DateTime.DateParse( MyDate)
	Private df As String = DateTime.DateFormat
	DateTime.DateFormat = "EEEE"
	Private res As String = DateTime.Date( Ticks)
	DateTime.DateFormat = df
	Return res
End Sub

'Returns the year of the date passed in MyDate.
'<code>
'Year("01/01/2013")  'Result: "2019"
'</code>
public Sub Year (MyDate As String) As String
	Return DateTime.GetYear( DateTime.DateParse( MyDate))
End Sub

'Returns Check LeapYear in Myyear.
'<code>
'IsLeapYear(2023)  'Result: False
'</code>
Public Sub IsLeapYear(MyYear As Int) As Boolean
    Return IfSelect((MyYear Mod 4 = 0 And MyYear Mod 100 <> 0) Or MyYear Mod 400 = 0, True, False)
End Sub

'Returns Get mime type by extension
'<code>
'GetMimeTypeByExtension("jpg") 'Result: "Image/jpg"
'</code>
Public Sub GetMimeTypeByExtension(Extension As String) As String
    Extension = Extension.Replace(".","").ToLowerCase
    Select Extension
        Case "jpg","png","gif","bmp","ico","svg","webp"
            Return "image/" & Extension
        Case "mp4", "avi", "mpeg", "wmv", "mov", "flv", "webm", "mkv"
            Return "video/" & Extension
        Case "mp3", "wav", "ogg", "m4a", "aac", "flac", "wma", "aiff"
            Return "audio/" & Extension
        Case Else
            Log("unknown mime type")
            Return ""
    End Select
End Sub	
 
 #End Region ------------------------------------ Date functions
 
